VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "ACM Codecs"
   ClientHeight    =   3375
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   9375
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3375
   ScaleWidth      =   9375
   StartUpPosition =   3  'Windows-Standard
   Begin VB.ListBox lstFormatinfo 
      Height          =   1620
      Left            =   5175
      TabIndex        =   11
      Top             =   1575
      Width           =   2415
   End
   Begin VB.ListBox lstFormats 
      Height          =   1620
      Left            =   2325
      TabIndex        =   7
      Top             =   1575
      Width           =   2640
   End
   Begin VB.ListBox lstDriverInfo 
      Height          =   840
      Left            =   4650
      TabIndex        =   6
      Top             =   375
      Width           =   4590
   End
   Begin VB.TextBox txtWFX 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   6.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1665
      Left            =   7800
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertikal
      TabIndex        =   5
      Top             =   1575
      Width           =   1440
   End
   Begin VB.ListBox lstFormatTags 
      Height          =   1620
      Left            =   150
      TabIndex        =   3
      Top             =   1575
      Width           =   1965
   End
   Begin VB.ListBox lstDrivers 
      Height          =   840
      Left            =   75
      TabIndex        =   0
      Top             =   375
      Width           =   4440
   End
   Begin VB.Label Label6 
      Caption         =   "Formatinfo:"
      Height          =   240
      Left            =   5175
      TabIndex        =   10
      Top             =   1350
      Width           =   1665
   End
   Begin VB.Label Label5 
      Caption         =   "Codec Info:"
      Height          =   240
      Left            =   4650
      TabIndex        =   9
      Top             =   150
      Width           =   1515
   End
   Begin VB.Label Label4 
      Caption         =   "Formats:"
      Height          =   240
      Left            =   2325
      TabIndex        =   8
      Top             =   1350
      Width           =   1665
   End
   Begin VB.Label Label3 
      Caption         =   "WAVEFORMATEX:"
      Height          =   240
      Left            =   7800
      TabIndex        =   4
      Top             =   1350
      Width           =   1515
   End
   Begin VB.Label Label2 
      Caption         =   "Format Tags:"
      Height          =   240
      Left            =   150
      TabIndex        =   2
      Top             =   1350
      Width           =   1515
   End
   Begin VB.Label Label1 
      Caption         =   "Codecs:"
      Height          =   165
      Left            =   75
      TabIndex        =   1
      Top             =   150
      Width           =   1515
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
    Dim i   As Integer

    ' get all codecs and their formats
    If ACMEnumCodecs Then
        For i = 0 To codecs.count - 1
            lstDrivers.AddItem StrConv(codecs.drivers(i).detail.szLongName, vbUnicode)
        Next
    Else
        MsgBox "Could not enum codecs.", vbExclamation
    End If
End Sub

Private Sub lstDrivers_Click()
    Dim i   As Integer

    lstFormatTags.Clear
    lstDriverInfo.Clear
    lstFormatinfo.Clear
    lstFormats.Clear
    txtWFX = ""

    With codecs.drivers(lstDrivers.ListIndex)
        ' show codec info
        lstDriverInfo.AddItem StrConv(.detail.szLongName, vbUnicode)
        lstDriverInfo.AddItem StrConv(.detail.szFeatures, vbUnicode)
        lstDriverInfo.AddItem StrConv(.detail.szCopyright, vbUnicode)
        lstDriverInfo.AddItem StrConv(.detail.szLicensing, vbUnicode)

        ' enum format tags
        For i = 0 To UBound(.tags)
            With .tags(i)
                lstFormatTags.AddItem StrConv(.detail.szFormatTag, vbUnicode)
            End With
        Next
    End With
End Sub

Private Sub lstFormatTags_Click()
    Dim i   As Integer

    ' enum formats of the current format tag
    lstFormatinfo.Clear
    lstFormats.Clear
    txtWFX = ""
    With codecs.drivers(lstDrivers.ListIndex).tags(lstFormatTags.ListIndex)
        For i = 0 To .formatcount - 1
            lstFormats.AddItem StrConv(.formats(i).detail.szFormat, vbUnicode)
        Next
    End With
End Sub

Private Function ArrToHex(arr() As Byte, dlen As Long) As String
    Dim i       As Integer

    For i = 0 To dlen - 1
        ArrToHex = ArrToHex & Right$("0" & Hex(arr(i)), 2) & " "
    Next
End Function

Private Sub lstFormats_Click()
    ' show waveformatex of current format
    With codecs.drivers(lstDrivers.ListIndex)
        With .tags(lstFormatTags.ListIndex)
            lstFormatinfo.Clear
            lstFormatinfo.AddItem "Format Tag: " & .detail.dwFormatTag
            lstFormatinfo.AddItem "Format Tag Index: " & .detail.dwFormatTagIndex
            lstFormatinfo.AddItem "WFX size: " & .detail.cbFormatSize
            lstFormatinfo.AddItem "Support Flags: " & Hex(.formats(lstFormats.ListIndex).detail.fdwSupport) & "h"
            txtWFX = ArrToHex(.formats(lstFormats.ListIndex).wfx, .detail.cbFormatSize)
        End With
    End With
End Sub
