VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "ACM MP3 Decoder"
   ClientHeight    =   2670
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   5640
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   178
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   376
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.Frame Frame1 
      Caption         =   "Input Format"
      Height          =   1065
      Left            =   345
      TabIndex        =   8
      Top             =   1050
      Width           =   2190
      Begin VB.PictureBox picFmt 
         BorderStyle     =   0  'Kein
         Height          =   765
         Left            =   75
         ScaleHeight     =   765
         ScaleWidth      =   2040
         TabIndex        =   9
         Top             =   225
         Width           =   2040
         Begin VB.Label lblSR 
            AutoSize        =   -1  'True
            Caption         =   "Sample Rate:"
            Height          =   195
            Left            =   150
            TabIndex        =   11
            Top             =   150
            Width           =   960
         End
         Begin VB.Label lblCh 
            AutoSize        =   -1  'True
            Caption         =   "Channels:"
            Height          =   195
            Left            =   150
            TabIndex        =   10
            Top             =   450
            Width           =   720
         End
      End
   End
   Begin MSComDlg.CommonDialog dlgWAV 
      Left            =   4245
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      Filter          =   "WAV (*.wav)|*.wav"
   End
   Begin MSComDlg.CommonDialog dlgMP3 
      Left            =   4275
      Top             =   525
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      Filter          =   "MPEG-3 (*.mp3)|*.mp3"
   End
   Begin VB.CommandButton cmdConvert 
      Caption         =   "Convert"
      Height          =   315
      Left            =   4095
      TabIndex        =   4
      Top             =   2250
      Width           =   1290
   End
   Begin VB.CommandButton cmdBrowseOut 
      Caption         =   "..."
      Height          =   315
      Left            =   4920
      TabIndex        =   3
      Top             =   600
      Width           =   540
   End
   Begin VB.TextBox txtOut 
      Height          =   315
      Left            =   795
      Locked          =   -1  'True
      TabIndex        =   2
      Top             =   600
      Width           =   4065
   End
   Begin VB.CommandButton cmdBrowseInp 
      Caption         =   "..."
      Height          =   315
      Left            =   4920
      TabIndex        =   1
      Top             =   150
      Width           =   540
   End
   Begin VB.TextBox txtInp 
      Height          =   315
      Left            =   795
      Locked          =   -1  'True
      TabIndex        =   0
      Top             =   150
      Width           =   4065
   End
   Begin MSComctlLib.ProgressBar prg 
      Height          =   315
      Left            =   345
      TabIndex        =   5
      Top             =   2250
      Width           =   3615
      _ExtentX        =   6376
      _ExtentY        =   556
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.Label lblOut 
      Alignment       =   1  'Rechts
      AutoSize        =   -1  'True
      Caption         =   "Output:"
      Height          =   195
      Left            =   150
      TabIndex        =   7
      Top             =   630
      Width           =   570
   End
   Begin VB.Label lblInp 
      AutoSize        =   -1  'True
      Caption         =   "Input:"
      Height          =   195
      Left            =   270
      TabIndex        =   6
      Top             =   180
      Width           =   450
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type FndFmt
    codec   As Integer
    fmttag  As Integer
    fmt     As Integer
End Type

Private wfxmp3pos   As FndFmt
Private clsMP3      As clsMP3Hdr
Private acm         As clsACM

Private Function GetMP3Fmt() As Boolean
    Dim i   As Integer
    Dim j   As Integer
    Dim k   As Integer
    Dim wfx As WAVEFORMATEX

    ' I'm assuming that the codec supports
    ' variable bitrates, so it doesn't
    ' 100% relate to the passed WFX struct
    ' but read the data directly from the Frame Header.
    ' So we simply look for a format with the same
    ' sample rate and channel count the input MP3 has.

    For i = 0 To codecs.count - 1
        For j = 0 To UBound(codecs.drivers(i).tags)
            For k = 0 To codecs.drivers(i).tags(j).formatcount - 1

                With codecs.drivers(i).tags(j).formats(k)
                    If .detail.dwFormatTag = WAVE_FORMAT_MPEGLAYER3 Then
                        CopyMemory wfx, .wfx(0), Len(wfx)

                        If wfx.nSamplesPerSec = clsMP3.Frequency Then
                            If wfx.nChannels = Choose(clsMP3.ChannelMode + 1, 2, 2, 2, 1) Then

                                wfxmp3pos.codec = i
                                wfxmp3pos.fmttag = j
                                wfxmp3pos.fmt = k
                                GetMP3Fmt = True
                                Exit Function

                            End If
                        End If

                    End If
                End With

            Next
        Next
    Next
End Function

Private Sub cmdBrowseInp_Click()
    On Error Resume Next
    dlgMP3.ShowOpen
    If Err Then Exit Sub

    clsMP3.FilePath = dlgMP3.FileName
    If 1 <> clsMP3.GetFileInfos Then
        MsgBox "Invalid MP3"
        Exit Sub
    End If

    If GetMP3Fmt Then
        txtInp = dlgMP3.FileName
        lblSR = "Sample Rate: " & clsMP3.Frequency
        lblCh = "Channels: " & Choose(clsMP3.ChannelMode + 1, 2, 2, 2, 1)
    Else
        MsgBox "No compatible format found.", vbExclamation
    End If
End Sub

Private Sub cmdBrowseOut_Click()
    On Error Resume Next
    dlgWAV.ShowSave
    If Err Then Exit Sub
    txtOut = dlgWAV.FileName
End Sub

Private Sub cmdConvert_Click()
    If txtInp = "" Then
        MsgBox "Input missing", vbExclamation
        Exit Sub
    End If
    If txtOut = "" Then
        MsgBox "Output missing", vbExclamation
        Exit Sub
    End If

    ConvertFile
End Sub

Private Sub ConvertFile()
    Dim FFIn            As Integer
    Dim FFOut           As Integer

    Dim bWFXIn()        As Byte
    Dim WFXOut          As WAVEFORMATEX
    Dim bWFXOut()       As Byte

    Dim bufferin()      As Byte
    Dim bufferout()     As Byte
    Dim realout()       As Byte

    Dim datain          As ChunkInfo
    Dim fileend         As Long
    Dim usedlen         As Long

    FFIn = FreeFile
    Open txtInp For Binary As #FFIn
    FFOut = FreeFile
    Open txtOut For Binary As #FFOut
    Seek #FFOut, 45

    ' jump to the first frame
    ' datalen is simply the end of the file
    Seek #FFIn, clsMP3.HeaderPosition + 1
    fileend = LOF(FFIn)

    ' prepare PCM WFX
    With WFXOut
        .nChannels = Choose(clsMP3.ChannelMode + 1, 2, 2, 2, 1)
        .nSamplesPerSec = clsMP3.Frequency
        .wBitsPerSample = 16    ' guessed
        .nAvgBytesPerSec = .nSamplesPerSec * .nChannels * .wBitsPerSample / 8
        .nBlockAlign = .wBitsPerSample / 8 * .nChannels
        .wFormatTag = WAVE_FORMAT_PCM
    End With

    ' move WFX structs to byte arrays
    ReDim bWFXOut(Len(WFXOut) - 1) As Byte
    CopyMemory bWFXOut(0), WFXOut, Len(WFXOut)

    With wfxmp3pos
        bWFXIn = codecs.drivers(.codec).tags(.fmttag).formats(.fmt).wfx
    End With

    ' create the stream
    If Not acm.CreateStream(0, bWFXIn, bWFXOut, 0) Then
        MsgBox "Couldn't create the stream", vbExclamation
        Exit Sub
    End If

    ' create input/output buffer
    ReDim bufferin(65535) As Byte
    ReDim bufferout(acm.StreamOutputSize(UBound(bufferin) + 1) - 1) As Byte

    ' add a stream header to the stream
    If -1 = acm.AddStreamHeader(VarPtr(bufferin(0)), UBound(bufferin) + 1, VarPtr(bufferout(0)), UBound(bufferout) + 1) Then
        MsgBox "Couldn't create stream header.", vbExclamation
        GoTo ExitFnc
    End If

    ' as long as we havn't reached the file end...
    Do While Seek(FFIn) + UBound(bufferin) + 1 < fileend

        ' fill input buffer and convert
        Get #FFIn, , bufferin
        If 1 <> acm.ConvertData(0, realout, , , usedlen) Then
            MsgBox "Conversion error", vbExclamation
            GoTo ExitFnc
        End If

        ' save data returned by ConvertData
        Put #FFOut, , realout

        ' if not the whole buffer got converted,
        ' seek back to the last converted byte
        If usedlen <> UBound(bufferin) + 1 Then
            Seek #FFIn, Seek(FFIn) - ((UBound(bufferin) + 1) - usedlen)
        End If

        On Error Resume Next
        prg.Value = Seek(FFIn) / LOF(FFIn) * 100
        On Error GoTo 0

        DoEvents

    Loop

    ' if there's a small piece of data left...
    If Seek(FFIn) < fileend Then
        Get #FFIn, , bufferin
        If 1 = acm.ConvertData(0, realout, fileend - (Seek(FFIn) - UBound(bufferin)) + 1, True) Then
            Put #FFOut, , realout
        End If
    End If

    Dim wavhdr  As WAV_Hdr
    With wavhdr
        .RIFF = "RIFF"                  ' RIFF Chunk
        .filesize = Seek(FFOut) - 8     ' File size
        .WAVEfmt = "WAVEfmt "           ' WAVE Format; fmt Chunk
        .fmtlen = 16                    ' fmt Chunk size
        .formattag = WAVE_FORMAT_PCM    ' Format Tag (PCM)
        .channels = WFXOut.nChannels    ' Channels
        .sps = WFXOut.nSamplesPerSec    ' Samples per second
        .bpsec = WFXOut.nAvgBytesPerSec ' Bytes per second
        .bla = WFXOut.nBlockAlign       ' Blockalign
        .bps = WFXOut.wBitsPerSample    ' Bits per Sample
        .data = "data"                  ' data Chunk
        .datalen = Seek(FFOut) - 44     ' Data Chunk size
    End With
    Put #FFOut, 1, wavhdr

    MsgBox "Finished", vbInformation

ExitFnc:
    acm.CloseStream
    Close #FFIn, #FFOut
End Sub

Private Sub Form_Load()
    Set clsMP3 = New clsMP3Hdr
    Set acm = New clsACM
    If Not ACMEnumCodecs Then
        MsgBox "Couldn't enum ACM Codecs.", vbExclamation
        Unload Me
    End If
End Sub
