VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "ACM MP3 Encoder"
   ClientHeight    =   3240
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   5655
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   216
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   377
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.Frame Frame2 
      Caption         =   "Output Format"
      Height          =   1515
      Left            =   2775
      TabIndex        =   13
      Top             =   1125
      Width           =   2640
      Begin VB.PictureBox picOutput 
         BorderStyle     =   0  'Kein
         Height          =   1215
         Left            =   75
         ScaleHeight     =   1215
         ScaleWidth      =   2490
         TabIndex        =   14
         Top             =   225
         Width           =   2490
         Begin VB.ListBox lstBitrate 
            Height          =   1170
            IntegralHeight  =   0   'False
            Left            =   30
            TabIndex        =   15
            Top             =   0
            Width           =   2415
         End
      End
   End
   Begin MSComDlg.CommonDialog dlgMP3 
      Left            =   4275
      Top             =   600
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      Filter          =   "MPEG-3 (*.mp3)|*.mp3"
   End
   Begin MSComDlg.CommonDialog dlgWAV 
      Left            =   4245
      Top             =   75
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      Filter          =   "WAV (*.wav)|*.wav"
   End
   Begin VB.TextBox txtInp 
      Height          =   315
      Left            =   795
      Locked          =   -1  'True
      TabIndex        =   10
      Top             =   225
      Width           =   4065
   End
   Begin VB.CommandButton cmdBrowseInp 
      Caption         =   "..."
      Height          =   315
      Left            =   4920
      TabIndex        =   9
      Top             =   225
      Width           =   540
   End
   Begin VB.TextBox txtOut 
      Height          =   315
      Left            =   795
      Locked          =   -1  'True
      TabIndex        =   8
      Top             =   675
      Width           =   4065
   End
   Begin VB.CommandButton cmdBrowseOut 
      Caption         =   "..."
      Height          =   315
      Left            =   4920
      TabIndex        =   7
      Top             =   675
      Width           =   540
   End
   Begin VB.CommandButton cmdConvert 
      Caption         =   "Konvertieren"
      Height          =   315
      Left            =   4095
      TabIndex        =   5
      Top             =   2775
      Width           =   1290
   End
   Begin VB.Frame Frame1 
      Caption         =   "Input Format"
      Height          =   1515
      Left            =   345
      TabIndex        =   0
      Top             =   1125
      Width           =   2190
      Begin VB.PictureBox picFmt 
         BorderStyle     =   0  'Kein
         Height          =   1215
         Left            =   75
         ScaleHeight     =   1215
         ScaleWidth      =   2040
         TabIndex        =   1
         Top             =   225
         Width           =   2040
         Begin VB.Label lblSR 
            AutoSize        =   -1  'True
            Caption         =   "Sample Rate:"
            Height          =   195
            Left            =   75
            TabIndex        =   4
            Top             =   150
            Width           =   960
         End
         Begin VB.Label lblCh 
            AutoSize        =   -1  'True
            Caption         =   "Channels:"
            Height          =   195
            Left            =   75
            TabIndex        =   3
            Top             =   450
            Width           =   720
         End
         Begin VB.Label lblBPS 
            AutoSize        =   -1  'True
            Caption         =   "Bits/Sample:"
            Height          =   195
            Left            =   75
            TabIndex        =   2
            Top             =   750
            Width           =   885
         End
      End
   End
   Begin MSComctlLib.ProgressBar prg 
      Height          =   315
      Left            =   345
      TabIndex        =   6
      Top             =   2775
      Width           =   3615
      _ExtentX        =   6376
      _ExtentY        =   556
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.Label lblInp 
      AutoSize        =   -1  'True
      Caption         =   "Input:"
      Height          =   195
      Left            =   270
      TabIndex        =   12
      Top             =   255
      Width           =   450
   End
   Begin VB.Label lblOut 
      Alignment       =   1  'Rechts
      AutoSize        =   -1  'True
      Caption         =   "Output:"
      Height          =   195
      Left            =   150
      TabIndex        =   11
      Top             =   705
      Width           =   570
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type FndFmt
    codec   As Integer
    fmttag  As Integer
    fmt     As Integer
End Type

Private fmts()  As FndFmt           ' ListBox.ItemData extension
Private wfx     As WAVEFORMATEX     ' Format of the input WAV
Private acm     As clsACM           ' ACM Converter class

Private Sub ShowBitrates()
    Dim i       As Integer
    Dim j       As Integer
    Dim l       As Integer

    Dim wfxMP3  As WAVEFORMATEX

    ReDim fmts(0) As FndFmt

    lstBitrate.Clear

    ' go through all drivers...
    For i = 0 To codecs.count - 1
        With codecs.drivers(i)

            ' and all codecs (format tags) in the driver...
            For j = 0 To UBound(.tags)

                ' found a MPEG-3 codec?
                If .tags(j).detail.dwFormatTag = &H55 Then

                    ' go through all formats of the codec
                    For l = 0 To .tags(j).formatcount - 1

                        ' compatible format?
                        CopyMemory wfxMP3, .tags(j).formats(l).wfx(0), Len(wfxMP3)
                        If wfxMP3.nSamplesPerSec = wfx.nSamplesPerSec Then
                            If wfxMP3.nChannels = wfx.nChannels Then

                                ' found a good one
                                With fmts(UBound(fmts))
                                    .codec = i
                                    .fmttag = j
                                    .fmt = l
                                End With
                                ReDim Preserve fmts(UBound(fmts) + 1)

                            End If
                        End If

                    Next    ' next format

                End If      ' MPEG-3?

            Next            ' next codec

        End With            ' codec.drivers(i)
    Next                    ' next driver

    ' found something?
    With fmts(0)
        If .codec = 0 And .fmt = 0 And .fmttag = 0 And UBound(fmts) = 0 Then
            MsgBox "No codecs found.", vbExclamation
            Exit Sub
        End If
    End With

    ' show compatible formats
    For i = 0 To UBound(fmts) - 1
        With fmts(i)
            lstBitrate.AddItem StrConv(codecs.drivers(.codec).tags(.fmttag).formats(.fmt).detail.szFormat, vbUnicode)
        End With
    Next
End Sub

Private Sub cmdBrowseInp_Click()
    Dim FF      As Integer

    On Error Resume Next
    dlgWAV.ShowOpen
    If Err Then Exit Sub
    On Error GoTo 0

    ' get fmt chunk position
    With GetWavChunkPos(dlgWAV.FileName, "fmt ")

        ' vali Chunk?
        If .Start <> 0 And .length <> 0 Then

            ' read Wave Format
            FF = FreeFile
            Open dlgWAV.FileName For Binary As #FF
                Get #FF, .Start + 1, wfx
            Close #FF

            If wfx.wFormatTag = WAVE_FORMAT_PCM Then
                txtInp = dlgWAV.FileName
                lblSR = "Sample Rate: " & wfx.nSamplesPerSec
                lblCh = "Channels: " & wfx.nChannels
                lblBPS = "Bits/Sample: " & wfx.wBitsPerSample
                ShowBitrates
            Else
                MsgBox "Only PCM WAV supported!", vbExclamation
            End If
        End If

    End With
End Sub

Private Sub cmdBrowseOut_Click()
    On Error Resume Next
    dlgMP3.ShowSave
    If Err Then Exit Sub
    txtOut = dlgMP3.FileName
End Sub

Private Sub cmdConvert_Click()
    If txtInp = "" Then
        MsgBox "Input missing", vbExclamation
        Exit Sub
    End If
    If txtOut = "" Then
        MsgBox "Output missing", vbExclamation
        Exit Sub
    End If

    ConvertFile
End Sub

Private Sub ConvertFile()
    Dim FFIn            As Integer
    Dim FFOut           As Integer

    Dim WFXIn           As WAVEFORMATEX
    Dim bWFXIn()        As Byte
    Dim bWFXOut()       As Byte

    Dim bufferin()      As Byte
    Dim bufferout()     As Byte
    Dim realout()       As Byte

    Dim datain          As ChunkInfo
    Dim fileend         As Long

    FFIn = FreeFile
    Open txtInp For Binary As #FFIn
    FFOut = FreeFile
    Open txtOut For Binary As #FFOut

    ' read fmt Chunk from input file
    With GetWavChunkPos(txtInp, "fmt ")
        Get #FFIn, .Start + 1, WFXIn
        WFXIn.cbSize = 0
    End With

    ' read data chunk position
    datain = GetWavChunkPos(txtInp, "data")
    ' skip chunk size
    datain.Start = datain.Start + 4
    ' set input file pointer to data chunk
    ' and determine the end of the chunk
    fileend = datain.Start + datain.length + 1
    Seek #FFIn, datain.Start + 1

    ' move WFX structures to byte arrays
    ReDim bWFXIn(Len(WFXIn) - 1) As Byte
    CopyMemory bWFXIn(0), WFXIn, Len(WFXIn)

    With fmts(lstBitrate.ListIndex)
        bWFXOut = codecs.drivers(.codec).tags(.fmttag).formats(.fmt).wfx
    End With

    ' create the stream
    If Not acm.CreateStream(0, bWFXIn, bWFXOut, 0) Then
        MsgBox "Konnte Stream nicht erstellen", vbExclamation
        Exit Sub
    End If

    ' create the input/output buffer
    ReDim bufferin(65535) As Byte
    ReDim bufferout(acm.StreamOutputSize(UBound(bufferin) + 1) - 1) As Byte

    ' add a stream header to the stream
    If -1 = acm.AddStreamHeader(VarPtr(bufferin(0)), UBound(bufferin) + 1, VarPtr(bufferout(0)), UBound(bufferout) + 1) Then
        MsgBox "Konnte Stream Header nicht erstellen.", vbExclamation
        GoTo ExitFnc
    End If

    ' as long as we havn't reached the chunk's end...
    Do While Seek(FFIn) + UBound(bufferin) + 1 < fileend

        ' fill input buffer and convert it
        Get #FFIn, , bufferin
        If 1 <> acm.ConvertData(0, realout) Then
            MsgBox "conversion error", vbExclamation
            GoTo ExitFnc
        End If

        ' save data returned by ConvertData
        Put #FFOut, , realout

        On Error Resume Next
        prg.Value = Seek(FFIn) / LOF(FFIn) * 100
        On Error GoTo 0

        DoEvents

    Loop

    ' if there's a small piece of data left...
    If Seek(FFIn) < fileend Then
        Get #FFIn, , bufferin
        If 1 = acm.ConvertData(0, realout, fileend - (Seek(FFIn) - UBound(bufferin)) + 1, True) Then
            Put #FFOut, , realout
        End If
    End If

    MsgBox "Finished", vbInformation

ExitFnc:
    acm.CloseStream
    Close #FFIn, #FFOut
End Sub

Private Sub Form_Load()
    Set acm = New clsACM
    If Not ACMEnumCodecs Then
        MsgBox "Couldn't enum ACM Codecs.", vbExclamation
        Unload Me
    End If
End Sub
