VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "ACM PCM WAV Resampler"
   ClientHeight    =   2820
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   5580
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   188
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   372
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.Frame Frame1 
      Caption         =   "Input Format"
      Height          =   1140
      Left            =   300
      TabIndex        =   10
      Top             =   1125
      Width           =   2190
      Begin VB.PictureBox picFmt 
         BorderStyle     =   0  'Kein
         Height          =   840
         Left            =   75
         ScaleHeight     =   840
         ScaleWidth      =   2040
         TabIndex        =   11
         Top             =   225
         Width           =   2040
         Begin VB.Label lblBPS 
            AutoSize        =   -1  'True
            Caption         =   "Bits/Sample:"
            Height          =   195
            Left            =   75
            TabIndex        =   14
            Top             =   525
            Width           =   885
         End
         Begin VB.Label lblCh 
            AutoSize        =   -1  'True
            Caption         =   "Channels:"
            Height          =   195
            Left            =   75
            TabIndex        =   13
            Top             =   300
            Width           =   720
         End
         Begin VB.Label lblSR 
            AutoSize        =   -1  'True
            Caption         =   "Sample Rate:"
            Height          =   195
            Left            =   75
            TabIndex        =   12
            Top             =   75
            Width           =   960
         End
      End
   End
   Begin VB.ComboBox cboSR 
      Height          =   315
      ItemData        =   "frmMain.frx":0000
      Left            =   4275
      List            =   "frmMain.frx":000D
      Style           =   2  'Dropdown-Liste
      TabIndex        =   9
      Top             =   1230
      Width           =   1065
   End
   Begin VB.CommandButton cmdConvert 
      Caption         =   "convert"
      Height          =   315
      Left            =   4050
      TabIndex        =   7
      Top             =   2400
      Width           =   1290
   End
   Begin MSComctlLib.ProgressBar prg 
      Height          =   315
      Left            =   300
      TabIndex        =   6
      Top             =   2400
      Width           =   3615
      _ExtentX        =   6376
      _ExtentY        =   556
      _Version        =   393216
      Appearance      =   1
   End
   Begin MSComDlg.CommonDialog dlg 
      Left            =   4200
      Top             =   75
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      Filter          =   "WAV (*.wav)|*.wav"
   End
   Begin VB.CommandButton cmdBrowseOut 
      Caption         =   "..."
      Height          =   315
      Left            =   4875
      TabIndex        =   5
      Top             =   675
      Width           =   540
   End
   Begin VB.TextBox txtOut 
      Height          =   315
      Left            =   750
      Locked          =   -1  'True
      TabIndex        =   4
      Top             =   675
      Width           =   4065
   End
   Begin VB.CommandButton cmdBrowseInp 
      Caption         =   "..."
      Height          =   315
      Left            =   4875
      TabIndex        =   2
      Top             =   225
      Width           =   540
   End
   Begin VB.TextBox txtInp 
      Height          =   315
      Left            =   750
      Locked          =   -1  'True
      TabIndex        =   1
      Top             =   225
      Width           =   4065
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "New Sample Rate:"
      Height          =   195
      Left            =   2850
      TabIndex        =   8
      Top             =   1275
      Width           =   1320
   End
   Begin VB.Label lblOut 
      Alignment       =   1  'Rechts
      AutoSize        =   -1  'True
      Caption         =   "Output:"
      Height          =   195
      Left            =   105
      TabIndex        =   3
      Top             =   705
      Width           =   570
   End
   Begin VB.Label lblInp 
      AutoSize        =   -1  'True
      Caption         =   "Input:"
      Height          =   195
      Left            =   225
      TabIndex        =   0
      Top             =   255
      Width           =   450
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private haid    As Long
Private acm     As clsACM

Private Sub cmdBrowseInp_Click()
    Dim wfx     As WAVEFORMATEX
    Dim FF      As Integer

    On Error Resume Next
    dlg.ShowOpen
    If Err Then Exit Sub
    On Error GoTo 0

    ' get fmt Chunk Position
    With GetWavChunkPos(dlg.FileName, "fmt ")

        ' valid Chunk?
        If .Start <> 0 And .length <> 0 Then

            ' read Wave Format
            FF = FreeFile
            Open dlg.FileName For Binary As #FF
                Get #FF, .Start + 1, wfx
            Close #FF

            If wfx.wFormatTag = WAVE_FORMAT_PCM Then
                txtInp = dlg.FileName
                lblSR = "Sample Rate: " & wfx.nSamplesPerSec
                lblCh = "Channels: " & wfx.nChannels
                lblBPS = "Bits/Sample: " & wfx.wBitsPerSample
            Else
                MsgBox "Only PCM WAV supported!", vbExclamation
            End If
        End If

    End With
End Sub

Private Sub cmdBrowseOut_Click()
    On Error Resume Next
    dlg.ShowSave
    If Err Then Exit Sub
    txtOut = dlg.FileName
End Sub

Private Sub cmdConvert_Click()
    If txtInp = "" Then
        MsgBox "Input missing", vbExclamation
        Exit Sub
    End If
    If txtOut = "" Then
        MsgBox "Output missing", vbExclamation
        Exit Sub
    End If

    ConvertFile
End Sub

Private Sub ConvertFile()
    Dim FFIn            As Integer
    Dim FFOut           As Integer

    Dim WFXIn           As WAVEFORMATEX
    Dim bWFXIn()        As Byte
    Dim WFXOut          As WAVEFORMATEX
    Dim bWFXOut()       As Byte

    Dim bufferin()      As Byte
    Dim bufferout()     As Byte
    Dim realout()       As Byte

    Dim datain          As ChunkInfo
    Dim fileend         As Long

    FFIn = FreeFile
    Open txtInp For Binary As #FFIn
    FFOut = FreeFile
    Open txtOut For Binary As #FFOut
    Seek #FFOut, 45

    ' get fmt Chunk from Input
    With GetWavChunkPos(txtInp, "fmt ")
        Get #FFIn, .Start + 1, WFXIn
        WFXIn.cbSize = 0
    End With

    ' read data chunk from input
    datain = GetWavChunkPos(txtInp, "data")
    ' skip chunksize
    datain.Start = datain.Start + 4
    ' set file pointer to data chunk of input
    ' and get the right end of the chunk
    fileend = datain.Start + datain.length + 1
    Seek #FFIn, datain.Start + 1

    ' set input to output format, only change sample rate
    WFXOut = WFXIn
    With WFXOut
        .nSamplesPerSec = CLng(cboSR.List(cboSR.ListIndex))
        .nAvgBytesPerSec = .nSamplesPerSec * .nChannels * (.wBitsPerSample / 8)
        .nBlockAlign = .wBitsPerSample / 8 * .nChannels
    End With

    ' move WFX structs to byte arrays
    ReDim bWFXIn(Len(WFXIn) - 1)
    ReDim bWFXOut(Len(WFXOut) - 1)
    CopyMemory bWFXIn(0), WFXIn, Len(WFXIn)
    CopyMemory bWFXOut(0), WFXOut, Len(WFXOut)

    ' create the stream
    ' because we havn't selected a codec to do the job,
    ' the ACM will automatically search for one which can do it
    If Not acm.CreateStream(0, bWFXIn, bWFXOut, ACM_STREAMOPENF_NONREALTIME) Then
        MsgBox "Couldn't create the stream", vbExclamation
        Exit Sub
    End If

    ' create input/output buffers
    ' output buffer is not important here,
    ' we'll get the right amount of data from ConvertData(),
    ' but the stream headers needs a buffer.
    ReDim bufferin(65535) As Byte
    ReDim bufferout(acm.StreamOutputSize(UBound(bufferin) + 1) - 1) As Byte

    ' add a stream header to the stream
    ' the first header has always index 0
    If -1 = acm.AddStreamHeader(VarPtr(bufferin(0)), UBound(bufferin) + 1, VarPtr(bufferout(0)), UBound(bufferout) + 1) Then
        MsgBox "Konnte Stream Header nicht erstellen.", vbExclamation
        GoTo ExitFnc
    End If

    ' as long as we havn't reached the chunk's end...
    Do While Seek(FFIn) + UBound(bufferin) + 1 < fileend

        ' fill the input buffer and convert it
        Get #FFIn, , bufferin
        If 1 <> acm.ConvertData(0, realout) Then
            MsgBox "conversion error", vbExclamation
            GoTo ExitFnc
        End If

        ' save data returned by ConvertData to the output file
        Put #FFOut, , realout

        On Error Resume Next
        prg.Value = Seek(FFIn) / LOF(FFIn) * 100
        On Error GoTo 0

        DoEvents

    Loop

    ' if there's a small piece of data left...
    If Seek(FFIn) < fileend Then
        Get #FFIn, , bufferin
        If 1 = acm.ConvertData(0, realout, fileend - (Seek(FFIn) - UBound(bufferin)) + 1, True) Then
            Put #FFOut, , realout
        End If
    End If

    ' write the WAV header
    Dim wavhdr  As WAV_Hdr
    With wavhdr
        .RIFF = "RIFF"                  ' RIFF Chunk
        .filesize = Seek(FFOut) - 8     ' file size
        .WAVEfmt = "WAVEfmt "           ' WAVE Format; fmt Chunk
        .fmtlen = 16                    ' fmt Chunk size
        .formattag = WAVE_FORMAT_PCM    ' Format Tag (PCM)
        .channels = WFXOut.nChannels    ' channel count
        .sps = WFXOut.nSamplesPerSec    ' Samples pro Second
        .bpsec = WFXOut.nAvgBytesPerSec ' Bytes pro Second
        .bla = WFXOut.nBlockAlign       ' Blockalign
        .bps = WFXOut.wBitsPerSample    ' Bits per Sample
        .data = "data"                  ' data Chunk
        .datalen = Seek(FFOut) - 44     ' Data Chunk size
    End With
    Put #FFOut, 1, wavhdr

    MsgBox "Finished", vbInformation

ExitFnc:
    acm.CloseStream
    Close #FFIn, #FFOut
End Sub

Private Sub Form_Load()
    Set acm = New clsACM
    If Not ACMEnumCodecs Then
        MsgBox "Couldn't enum codecs.", vbExclamation
        Unload Me
    End If
    cboSR.ListIndex = 2
End Sub
